
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Treatment functions &#8212; Battery SOH  documentation</title>
    
  <link href="../_static/css/theme.css" rel="stylesheet" />
  <link href="../_static/css/index.c5995385ac14fb8791e8eb36b4908be2.css" rel="stylesheet" />

    
  <link rel="stylesheet"
    href="../_static/vendor/fontawesome/5.13.0/css/all.min.css">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-solid-900.woff2">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-brands-400.woff2">

    
      

    
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/basic.css" />
    <link rel="stylesheet" type="text/css" href="../_static/css/custom.css" />
    
  <link rel="preload" as="script" href="../_static/js/index.1c5a1a01449ed65a7b51.js">

    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="Models" href="Models.html" />
    <link rel="prev" title="Tarascon’s Coin dataset" href="COIN.html" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <meta name="docsearch:language" content="en" />
    
  </head>
  <body data-spy="scroll" data-target="#bd-toc-nav" data-offset="80">
    
    <div class="container-fluid" id="banner"></div>

    
    <nav class="navbar navbar-light navbar-expand-lg bg-light fixed-top bd-navbar" id="navbar-main"><div class="container-xl">

  <div id="navbar-start">
    
    

<a class="navbar-brand" href="../index.html">
  <img src="../_static/logo.png" class="logo" alt="logo">
</a>


    
  </div>

  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbar-collapsible" aria-controls="navbar-collapsible" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  
  <div id="navbar-collapsible" class="col-lg-9 collapse navbar-collapse">
    <div id="navbar-center" class="mr-auto">
      
      <div class="navbar-center-item">
        <ul id="navbar-main-elements" class="navbar-nav">
    <li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Colabs.html">
  Google Colabs
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="main.html">
  Useful dictionaries
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Battery%20Classes.html">
  Battery Classes
 </a>
</li>

<li class="toctree-l1 current active nav-item">
 <a class="current reference internal nav-link" href="#">
  Treatment functions
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Models.html">
  Models
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Training.html">
  Training and Simulation
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Report.html">
  Report related
 </a>
</li>

    
</ul>
      </div>
      
    </div>

    <div id="navbar-end">
      
      <div class="navbar-end-item">
        <ul id="navbar-icon-links" class="navbar-nav" aria-label="Icon Links">
      </ul>
      </div>
      
    </div>
  </div>
</div>
    </nav>
    

    <div class="container-xl">
      <div class="row">
          
            
            <!-- Only show if we have sidebars configured, else just a small margin  -->
            <div class="col-12 col-md-3 bd-sidebar"><form class="bd-search d-flex align-items-center" action="../search.html" method="get">
  <i class="icon fas fa-search"></i>
  <input type="search" class="form-control" name="q" id="search-input" placeholder="Search the docs ..." aria-label="Search the docs ..." autocomplete="off" >
</form><nav class="bd-links" id="bd-docs-nav" aria-label="Main navigation">
  <div class="bd-toc-item active">
    
  </div>
</nav>
            </div>
            
          

          
          <div class="d-none d-xl-block col-xl-2 bd-toc">
            
              
              <div class="toc-item">
                

<nav id="bd-toc-nav">
    
</nav>
              </div>
              
              <div class="toc-item">
                
              </div>
              
            
          </div>
          

          
          
            
          
          <main class="col-12 col-md-9 col-xl-7 py-md-5 pl-md-5 pr-md-4 bd-content" role="main">
              
              <div>
                
  <div class="section" id="treatment-functions">
<h1>Treatment functions<a class="headerlink" href="#treatment-functions" title="Permalink to this headline">¶</a></h1>
<p>Functions used for cleaning <a class="reference internal" href="Battery%20Classes.html"><span class="doc">Battery Classes</span></a>
data or for dataset creation.</p>
<span class="target" id="module-Cleaning"></span><dl class="py function">
<dt class="sig sig-object py" id="Cleaning.Input_outliers_v3">
<span class="sig-prename descclassname"><span class="pre">Cleaning.</span></span><span class="sig-name descname"><span class="pre">Input_outliers_v3</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">Data</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">feature_index</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">0</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">window</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">50</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/Cleaning.html#Input_outliers_v3"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Cleaning.Input_outliers_v3" title="Permalink to this definition">¶</a></dt>
<dd><p>This function identifies and takes away the outliers present in the
dataset.</p>
<p>This is a third version of the previous <cite>Input_outliers</cite> function. It is
more general in the sense that it takes as input a whole dataset matrix
instead of the separate vectors and can thus study differently sized data.</p>
<p>Most of the work is still done by the function <cite>Outliers_idx</cite>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>Data</strong> (<em>ndarray</em><em>[</em><em>float</em><em>]</em>) – The cycle’s data. Each column must be a different feature.</p>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p><ul class="simple">
<li><p>An np.ndarray of the <cite>New_Data</cite>, without the outliers, and a boolean</p></li>
<li><p>np.ndarray <cite>outlier_array</cite> with information about where the outliers are</p></li>
<li><p><em>located.</em></p></li>
</ul>
</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="Cleaning.Outliers">
<span class="sig-prename descclassname"><span class="pre">Cleaning.</span></span><span class="sig-name descname"><span class="pre">Outliers</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">cycle_couple</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">capacity_curve</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">z_lim</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">3</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/Cleaning.html#Outliers"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Cleaning.Outliers" title="Permalink to this definition">¶</a></dt>
<dd><p>Removes outliers from the battery’s output capacity data.</p>
<p>As of know, it removes outliers based on moving window averages (generalized
Extreme Studentized Deviate (ESD) test - implemented through PyAstronomy’s
pyasl.pointDistGESD) and on zscore (by taking away any remaining points with
a z-score &gt; z_lim). Where z_score_i = x_i - mean(x)/std(x).</p>
<p>This function is called by the class <cite>Clean_Battery</cite> in Nasa_Classes.py.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>cycle_couple</strong> (<em>list</em><em>[</em><em>tuple</em><em>(</em><a class="reference internal" href="NASA.html#Nasa_Classes.Clean_Cycle" title="Nasa_Classes.Clean_Cycle"><em>Clean_Cycle</em></a><em>)</em><em>]</em>) – The list of tuples associated to each cycle couple. It’s a necessary
input because it will be updated as we remove outliers.</p></li>
<li><p><strong>capacity_curve</strong> (<em>list</em><em>[</em><em>tuple</em><em>(</em><em>float</em><em>)</em><em>]</em>) – List of tuples (<cite>capacity points</cite>). Each tuple corresponds to one
capacity point. The first entry is the cycle_couple index associated to
the capacity value - which is the second entry.</p></li>
<li><p><strong>z_lim</strong> (<em>float</em>) – The maximum zscore allowed when searching for outliers.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p><ul class="simple">
<li><p><strong>cycle_couple</strong> (<em>list[tuple(Clean_Cycle)]</em>) – The list of tuples associated to cycle couple after outlier removal.</p></li>
<li><p><strong>capacity_curve</strong> (<em>ndarray</em>) – A 2D array containing in the cycle_couple index in the first column and
the associated capacity value in the second.</p></li>
</ul>
</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="Cleaning.Outliers_idx">
<span class="sig-prename descclassname"><span class="pre">Cleaning.</span></span><span class="sig-name descname"><span class="pre">Outliers_idx</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">inputs</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">force</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">False</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">outlier_lim</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">20</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/Cleaning.html#Outliers_idx"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Cleaning.Outliers_idx" title="Permalink to this definition">¶</a></dt>
<dd><p>Identifies outliers in a data array and outputs their indexes.</p>
<p>As of know, it only removes outliers based on moving window averages
(generalized Extreme Studentized Deviate (ESD) test - implemented through
PyAstronomy’s pyasl.pointDistGESD).</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>inputs</strong> (<em>ndarray</em>) – The array of data we want to find the outliers of.</p></li>
<li><p><strong>force</strong> (<em>bool</em><em>, </em><em>optional</em>) – <p>Whether or not to let the data pass (don’t take away any outliers) when
ZeroDivisionError is raised during outlier identification.</p>
<p>This error may be raised when the array is completely constant (but not
always, apparently…) - depending on what we’re studying, it may make
sense to discard the data (force = False) and in others not (force =
True).</p>
</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>A list containing the index of each outlier.</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>list[ints]</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="Cleaning.Resampling_flexible">
<span class="sig-prename descclassname"><span class="pre">Cleaning.</span></span><span class="sig-name descname"><span class="pre">Resampling_flexible</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">Cycle</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">variable</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'Voltage'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">time_step</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">0.01</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">min_var</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">max_var</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">min_len</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">nan_lim</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">time_diff_lim</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/Cleaning.html#Resampling_flexible"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Cleaning.Resampling_flexible" title="Permalink to this definition">¶</a></dt>
<dd><p>This function resamples a cycle’s data to a desired step, while also
keeping an eye for NaNs and correcting them when necessary.</p>
<p>It differs from Resampling_v3 because it is more general: it can resample
data based on variables other than time. In particular, it’s used for
resampling capacity data in function of voltage for the Severson dataset
creation (Torch_Dataset_SEV in FFNN.py). In it, features are extracted from
the difference between two Q(V) curves.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>If the cycle is deemed as too short or abnormal, then all of the arrays
are returned as <cite>None</cite>.</p>
</div>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>Cycle</strong> (<a class="reference internal" href="MIT.html#MIT_Classes.Clean_MIT_Cycle" title="MIT_Classes.Clean_MIT_Cycle"><em>Clean_MIT_Cycle</em></a><em> or </em><a class="reference internal" href="NASA.html#Nasa_Classes.Clean_Cycle" title="Nasa_Classes.Clean_Cycle"><em>Clean_Cycle</em></a>) – <p>A cycle_like object containing time, current, voltage and temperature
data (for a Clean_Cycle class), or time, current, voltage, temperature
and capacity data (for Clean_MIT_Cycle classes).</p>
<p>Units: [s], [A], [V], [ºC] and [A.h] (when applicable) respectively.</p>
</p></li>
<li><p><strong>variable</strong> (<em>str</em><em>, </em><em>default = 'Voltage'</em>) – The desired variable to use as a base for the resampling.
Can either be ‘Time’, ‘Voltage’, ‘Current’, ‘Temperature’ or ‘Capacity’.</p></li>
<li><p><strong>time_step</strong> (<em>float</em><em>, </em><em>default = 0.01</em>) – The desired step for resampling. The unit will depend on the variable
but it has to follow the input convention.</p></li>
<li><p><strong>min_var</strong> (<em>float</em><em>, </em><em>default = 2.</em>) – The lower bound of the resampling.</p></li>
<li><p><strong>max_var</strong> (<em>float</em><em>, </em><em>default = 4.</em>) – The higher bound of the resampling.</p></li>
<li><p><strong>min_len</strong> (<em>int</em><em>, </em><em>default = 1</em>) – The minimum length (number of points) the cycle must have at the end of
the resampling for it to be considered relevant.</p></li>
<li><p><strong>nan_lim</strong> (<em>int</em><em>, </em><em>default = 1</em>) – The amount of NaNs the resampled vector must have to print a warning and
return None.</p></li>
<li><p><strong>time_diff_lim</strong> (<em>float</em><em>, </em><em>optional</em>) – <p>The biggest time jump the raw dataset can have before resampling.</p>
<p>If the dataset has a time jump that is too big, resampling is
compromised and the data cannot be used (simple interpolation can’t
reproduce the missing data), returns <code class="docutils literal notranslate"><span class="pre">None</span></code>.
If no value is suggested, it defaults to 10 times the <code class="docutils literal notranslate"><span class="pre">time_step</span></code>
size.</p>
</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p></p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>An np.ndarray with the resampled data.</p>
</dd>
<dt class="field-even">Raises</dt>
<dd class="field-even"><ul class="simple">
<li><p><strong>AssertionError</strong> – If Cycle.type == ‘impedance’ (when the input Cycle is a Clean_Cycle).
    If min_len &lt; 1.</p></li>
<li><p><strong>NameError</strong> – If the dataset type is unknown. Only Nasa and Severson dataset types are
    currently supported (<code class="docutils literal notranslate"><span class="pre">Clean_Cycle</span></code> and <code class="docutils literal notranslate"><span class="pre">Clean_MIT_Cycle</span></code> classes).</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="Cleaning.ranges">
<span class="sig-prename descclassname"><span class="pre">Cleaning.</span></span><span class="sig-name descname"><span class="pre">ranges</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">nums</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/Cleaning.html#ranges"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Cleaning.ranges" title="Permalink to this definition">¶</a></dt>
<dd><p>Finds groups of consecutive numbers in a list and outputs a tuple with the
first and last values of each group.</p>
<p>Gotten from: <a class="reference external" href="https://stackoverflow.com/questions/2361945/detecting-consecutive-integers-in-a-list">https://stackoverflow.com/questions/2361945/detecting-consecutive-integers-in-a-list</a></p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>nums</strong> (<em>list</em><em>[</em><em>int</em><em>]</em>) – The list with the integers.</p>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>A list containing the tuples.</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>list[tuple(int,int)]</p>
</dd>
</dl>
<p class="rubric">Examples</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="n">A_list</span> <span class="o">=</span> <span class="p">[</span><span class="mi">1</span><span class="p">,</span> <span class="mi">2</span><span class="p">,</span> <span class="mi">3</span><span class="p">,</span> <span class="mi">4</span><span class="p">,</span> <span class="mi">7</span><span class="p">,</span> <span class="mi">9</span><span class="p">,</span> <span class="mi">10</span><span class="p">]</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">ranges</span><span class="p">(</span><span class="n">A_list</span><span class="p">)</span>
<span class="go">[(1,4), (7,7), (9,10)]</span>
</pre></div>
</div>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="Cleaning.Normalize">
<span class="sig-prename descclassname"><span class="pre">Cleaning.</span></span><span class="sig-name descname"><span class="pre">Normalize</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">inputs</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">output</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">norm_type</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'zscore'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">norm</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">concatenate</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">False</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/Cleaning.html#Normalize"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Cleaning.Normalize" title="Permalink to this definition">¶</a></dt>
<dd><p>Normalizes both the inputs and outputs based either on z-score or on min-max
normalization.</p>
<p>All of the necessary normalization information is stored in the <cite>norm</cite> tuple
as follows:</p>
<dl class="simple">
<dt>If <cite>norm_type</cite> == ‘zscore’:</dt><dd><dl class="simple">
<dt>norm = (inputs’ mean, inputs’ standard deviation,</dt><dd><p>outputs’ mean, outputs’ standard deviation, ‘zscore’)</p>
</dd>
</dl>
</dd>
<dt>elif <cite>norm_type</cite> == ‘minmax’:</dt><dd><dl class="simple">
<dt>norm = (min(inputs), max(inputs),</dt><dd><p>min(output), max(output), ‘minmax’)</p>
</dd>
</dl>
</dd>
</dl>
<p>This normalization information can then be used as an input for this
function for normalizing other datasets.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>If a <cite>norm</cite> tuple is specified, the specified <cite>norm_type</cite> will be
overridden by the one in <cite>norm[4]</cite>.</p>
</div>
<p>The normalization procedure does take into account cases where the standard
deviation or the difference max - min equals zero (constant inputs or
outputs). The standard deviation and (max - min) values may be overridden to
1 in order to avoid division by zero. In some cases, an AssertionError may
be raised.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>inputs</strong> (<em>list</em><em>[</em><em>Tensor</em><em>]</em>) – The list containing the input tensors.</p></li>
<li><p><strong>output</strong> (<em>list</em><em>[</em><em>float</em><em>]</em>) – The list containing the output capacity values.</p></li>
<li><p><strong>norm_type</strong> (<em>{'zscore'</em><em>, </em><em>'minmax'}</em>) – A string indicating which kind of normalization to do.</p></li>
<li><p><strong>norm</strong> (<em>tuple</em><em>(</em><em>Tensor</em><em>, </em><em>Tensor</em><em>, </em><em>Tensor</em><em>, </em><em>Tensor</em><em>, </em><em>string</em><em>)</em><em>, </em><em>optional</em>) – A tuple containing all of the information necessary for normalization.
In entered as input, <cite>norm_type</cite> will be overridden by norm[4] and the
given information will be used for the normalization</p></li>
<li><p><strong>concatenate</strong> (<em>bool</em>) – Whether or not to return the normalized concatenated inputs
instead of normalizing each input separately and returning a list.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p><ul class="simple">
<li><p><strong>inputs</strong> (<em>list[Tensor] or Tensor</em>) – The normalized inputs. If concatenate == True, then it’s a simple Tensor,
otherwise, it’s a list of tensors.</p></li>
<li><p><strong>output_stack</strong> (<em>Tensor</em>) – The normalized outputs.</p></li>
<li><p><strong>norm</strong> (<em>tuple(Tensor, Tensor, Tensor, Tensor, string)</em>) – The normalization information used for normalizing the inputs and the
outputs.</p></li>
</ul>
</p>
</dd>
<dt class="field-odd">Raises</dt>
<dd class="field-odd"><p><strong>AssertionError</strong> – When all of the inputs or all of the outputs are constant.
    When normalization type is not supported</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="Cleaning.Denormalize">
<span class="sig-prename descclassname"><span class="pre">Cleaning.</span></span><span class="sig-name descname"><span class="pre">Denormalize</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">tensor</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">norm</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">inputs</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">False</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/Cleaning.html#Denormalize"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Cleaning.Denormalize" title="Permalink to this definition">¶</a></dt>
<dd><p>Function for “denormalizing” input or output data.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>tensor</strong> (<em>torch.Tensor</em>) – The tensor with the information to be denormalized</p></li>
<li><p><strong>norm</strong> (<em>tuple</em><em>(</em><em>Tensor</em><em>, </em><em>Tensor</em><em>, </em><em>Tensor</em><em>, </em><em>Tensor</em><em>, </em><em>string</em><em>)</em>) – The normalization information used for normalizing the inputs and the
outputs.</p></li>
<li><p><strong>inputs</strong> (<em>bool</em><em>, </em><em>default = False</em>) – Whether or not the given tensor is an input or an output type.
This is necessary because they’ll use different normalization
information.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>The denormalized tensor.</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>th.Tensor</p>
</dd>
</dl>
</dd></dl>

</div>


              </div>
              
              
              <div class='prev-next-bottom'>
                
    <a class='left-prev' id="prev-link" href="COIN.html" title="previous page">Tarascon’s Coin dataset</a>
    <a class='right-next' id="next-link" href="Models.html" title="next page">Models</a>

              </div>
              
          </main>
          

      </div>
    </div>
  
  <script src="../_static/js/index.1c5a1a01449ed65a7b51.js"></script>

  <footer class="footer mt-5 mt-md-0">
  <div class="container">
    
    <div class="footer-item">
      <p class="copyright">
    &copy; Copyright 2021, Antonio Rocha Azevedo.<br/>
</p>
    </div>
    
    <div class="footer-item">
      <p class="sphinx-version">
Created using <a href="http://sphinx-doc.org/">Sphinx</a> 4.0.2.<br/>
</p>
    </div>
    
  </div>
</footer>
  </body>
</html>